#include <cstdio>
#include <cstdlib>

int n,q,m;

unsigned char gmatr[1000][1000];
int queue[2000];

char reach(int i,int j)
{
    if(gmatr[i][j])return 1;
    int qa=0,qb=0;
    bool visited[1000]={0};
    visited[i]=1;
    for(int k=0;k<n;k++)
    {
        if((!visited[k])&&gmatr[i][k]){
            visited[k]=1;
            if(k==j)return 1;
            queue[qa+qb]=k;
            qb++;
        }
    }
    if(visited[j])return 1;
    while(qb>0)
    {
        for(int k=0;k<n;k++)
        {
            if((!visited[k])&&gmatr[queue[qa]][k])
            {
                visited[k]=1;
                if(k==j)return 1;
                queue[qa+qb]=k;
                qb++;
            }
        }
        qa++;
        qb--;
    }
    if(visited[j])return 1;
    return 0;
}

void init()
{
    for(int i=0;i<n;i++)gmatr[i][i]=1;
}

void input()
{
    scanf("%d %d",&n,&m);
    for(int i=0;i<m;i++)
    {
        int f,t;
        scanf("%d %d",&f,&t);
        t--,f--;
        gmatr[f][t]=gmatr[t][f]=1;
    }
    init();
    scanf("%d",&q);
}
void solve()
{
    input();
    for(int i=0;i<q;i++)
    {
        int callt;
        int f,t;
        scanf("%d %d %d",&callt,&f,&t);
        f--,t--;
        switch(callt)
        {
            case 1:printf("%d",reach(f,t));break;
            case 2:gmatr[f][t]=gmatr[t][f]=1;break;
            case 3:gmatr[f][t]=gmatr[t][f]=0;break;
        }
    }
}

int main()
{
 solve();
 return 0;
}