#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <map>
#include <algorithm>
#define MAXN 1024
using namespace std;

int n, m, q, x, y, t;
int graph[MAXN][MAXN];

int graph_c[MAXN], cur_c = 1, graph_eq[MAXN];
bool used[MAXN];

void dfs(int v){
    if(v==-1) return ;
    used[v] = 1;
    graph_c[v] = cur_c;
    for(int i = 1; i <= graph[v][0]; i++){
        if(!used[graph[v][i]]) dfs(graph[v][i]);
    }
}

bool is_connected(int x, int y){
    for(int i = 1; i <= graph[x][0]; i++){
        if(graph[x][i]==y) return true;
    }
    return false;
}

void make_eq(int x, int y){
    graph_eq[x] = y;
    graph_eq[y] = x;
}

int main(){
    scanf("%d %d", &n, &m);
    for(int i = 0; i < m; i++){
        scanf("%d %d", &x, &y);
        graph[x][graph[x][0]+1] = y;
        graph[x][0]++;
        graph[y][graph[y][0]+1] = x;
        graph[y][0]++;
    }
    for(int i = 1; i <= n; i++){
        if(!used[i]){
        dfs(i);
        cur_c++;
        }
    }


    scanf("%d", &q);
    for(int i = 0; i < q; i++){
        scanf("%d %d %d", &t, &x, &y);
        if(t==1){
            if(graph_c[x]==graph_c[y] || graph_eq[graph_c[x]]==graph_c[y]){
            printf("%d", 1);
            }else{
            printf("%d", 0);
            }
        }else if(t==2){
            if(is_connected(x, y)==0){
                    graph[x][graph[x][0]+1] = y;
                    graph[x][0]++;
                    graph[y][graph[y][0]+1] = x;
                    graph[y][0]++;
            }

            if(graph_c[x]==graph_c[y] || graph_eq[graph_c[x]]==graph_c[y]) ;
            else{
                make_eq(graph_c[x], graph_c[y]);
            }

        }else if(t==3){
            for(int k = 1; k <= graph[x][0]; k++){
            if(graph[x][k]==y) graph[x][k] = -1;
            }
            for(int k = 1; k <= graph[y][0]; k++){
            if(graph[y][k]==x) graph[y][k] = -1;
            }
            dfs(x);
            cur_c++;
            dfs(y);
        }
    }
    cout << endl;

return 0;
}
