#include <cstdio>
#include <vector>
#include <queue>
using namespace std;

int n, m, q, u, v, i, j, k, curq, code, qfr, vsize;
vector <int> a[1010];
int used[1010];

int bfs(int x, int y)
{
    queue<int>q;
    q.push(x);
    while(!q.empty())
    {
        qfr=q.front();
        q.pop();
        if(qfr==y) return 1;
        vsize=a[qfr].size();
        for(k=0; k<vsize; k++)
        {
            if(used[a[qfr][k]]!=curq)
            {
                used[a[qfr][k]]=curq;
                q.push(a[qfr][k]);
            }
        }
    }
    return 0;
}

int main()
{
    scanf("%d %d", &n, &m);
    for(i=0; i<m; i++)
    {
        scanf("%d %d", &u, &v);
        a[u].push_back(v);
        a[v].push_back(u);
    }
    scanf("%d", &q);
    curq=1;
    for(i=0; i<q; i++)
    {
        scanf("%d %d %d", &code, &u, &v);
        if(code == 1)
        {
            printf("%d", bfs(u,v));
            curq++;
        }
        else if(code == 2)
        {
            a[u].push_back(v);
            a[v].push_back(u);
        }
        else if(code == 3)
        {
            vsize = a[u].size();
            for(j=0; j<vsize; j++)
            {
                if(a[u][j]==v) a[u][j]=0;
            }
            vsize=a[v].size();
            for(j=0; j<vsize; j++)
            {
                if(a[v][j]==u) a[v][j]=0;
            }
        }
    }
    printf("\n");
	return 0;
}
