#include<cstdio>
#include<cmath>
#include<conio.h>

using namespace std;

 float a, b, c;
 float diag;
 
 int convertToInt(float x)
 {
     int ret = (int)(x * 1000);
     if (ret % 10 > 4 ) ret += 10;
     ret /= 10;
     return ret;
 }
 
float findAns(float min, float max)
 {
     float prevX = 0;
     while (min < max)
     {
         float mid = min + max;
         mid = mid / 2.0; // 7.5
         float y = sqrt((c * c) - (mid * mid)); // 13
         float p = (y * (b - y));
         p = p / mid; // 64.13
         float x = sqrt(p * p + (b - y) * (b - y)); // 73
         if (fabs(x - prevX) < 0.01) return x;
         if (p + mid >= a && x > a) 
         {
             prevX = x;
             min = mid;
         }
         else 
         {
             prevX = x;
             max = mid;
         }
     }
     return prevX;
 }

int main()
{
    scanf("%f %f %f", &a, &b, &c);
    diag = sqrt(a * a + b * b);
    float ans = findAns(0.00, c);
    if (ans < a)
    {
        float m = 1.0;
        float t = c;
        while (t > 0)
        {
            t /= 10;
            m /= 10;
        }
        ans = a + ((a * (m * (b - c))) / 2);
    }
    printf("%.2f\n", ans);
    return 0;
}