#include<cstdio>
#include<string>
#include<iostream>

using namespace std;

const int NMAX = 1024;

bool a[NMAX][NMAX];
bool used[NMAX];
int colors[NMAX];
int maxColor = 0;
string ans;

int n, m, q;

void color2(int start, int color)
{
    colors[start] = color;
    for (int i = 1; i <= n; i++)
    {
        if (colors[i] == 0 && a[start][i])
            color2(i, color);
    }
}

void init()
{
    scanf("%d %d", &n, &m);
    int u, v;
    for (int i = 0; i < m; i++)
    {
        scanf("%d %d", &u, &v);
        a[u][v] = true;
        a[v][u] = true;
    }
    for (int i = 1; i <= n; i++)
    {
        if (colors[i] == 0)
        {
            maxColor++;
            color2(i, maxColor);
        }
    }
}

void print(bool a[NMAX][NMAX])
{
    for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j <= n; j++)
            printf("%d  ", a[i][j]);
        printf("\n");
    }
}

void ColorAll(int start, int color)
{
    used[start] = true;
    colors[start] = color;
    for (int i = 0; i <= n; i++)
        if (a[start][i] && !used[i])
            ColorAll(i, color);
}

void sol()
{
    int q;
    scanf("%d", &q);
    int type, u, v;
    for (int i = 0; i < q; i++)
    {
        scanf("%d %d %d", &type, &u, &v);
        if (type == 1)
        {
            if (colors[u] == colors[v]) ans += "1";
            else ans += "0";
        }
        else if (type == 2)
        {
            a[u][v] = true;
            a[v][u] = true;
            if (colors[u] != colors[v])
            {
                for (int i = 1; i <= n; i++) used[i] = false;
                maxColor++;
                ColorAll(u, maxColor);
            }
        }
        else
        {
            for (int i = 1; i <= n; i++) used[i] = false;
            a[u][v] = false;
            a[v][u] = false;
            maxColor++;
            ColorAll(u, maxColor);
            if (colors[v] != maxColor) 
            {
                maxColor++;
                ColorAll(v, maxColor);
            }
        }
    }
    cout << ans << endl;
}

int main()
{
    init();
    sol();
    return 0;
}