#include<cstdio>
#include<iostream>

using namespace std;

long long gen_next_pal(long long currentPal, int n, int increment)
{
    long long t = (long long)1;
    
    for (int i = 0; i < n / 2; i++)
        t *= 10;
    long long nextPal = currentPal / t;
    nextPal += increment;
    currentPal /= t;
    currentPal += increment;
    if (n % 2 == 1)
        currentPal /= 10;
    while (currentPal > 0)
    {
        nextPal *= 10;
        nextPal += currentPal % 10;
        currentPal /= 10;
    }
    return nextPal;
}

int sol(int n, int p)
{
    int cnt = 0;
    long long pal = (long long) 1;
    long long limit = (long long)10;
    for (int i = 1; i < n; i++)
    {
        pal *= 10;
        limit *= 10;
    }
    pal++;
    while (pal < limit)
    {
        if (pal % p == 0) cnt++;
        pal = gen_next_pal(pal, n, 1);
    }
    return cnt;
}

int main()
{
    int n;
    long long p;
    cin >> n >> p;
    if (p % 10 == 0) 
    {
        printf("%d\n", 0);
        return 0;
    }
    printf("%d\n", sol(n, p));
    return 0;
}