#include <iostream>
#include <vector>
#include <map>
using namespace std;
int N, M, Q;
vector<map<short, short> > paths;
map<short, short> tried;
int destination;

bool testRoute(int bg)
{
    tried[bg] = 1;
    for(map<short, short>::iterator iter = paths[bg].begin(); iter != paths[bg].end(); iter++)
    {
        if(tried[iter->first] != 1 && paths[bg][iter->first] == 1)
        {
            if(paths[bg][destination] == 1)
                return 1;
            else
            {
                if(testRoute(iter->first) == 1) return 1;
            }
        }
    }
    return false;
}

int main()
{
    cin >> N >> M;
    vector<short> outputS;
    for(int i = 0; i <= N; i++)
    {
        map<short, short> a;
        paths.push_back(a);
    }
    for(int i = 0; i < M; i++)
    {
        int a, b;
        cin >> a >> b;
        paths[a][b] = 1;
        paths[b][a] = 1;
    }

    cin >> Q;
    for(int i = 0; i < Q; i++)
    {
        int a, b, c;
        cin >> a >> b >> c;
        if(a == 1)
        {
            destination = c;
            outputS.push_back(testRoute(b));
            tried.clear();
        }
        else if(a == 2)
        {
            paths[b][c] = 1;
            paths[c][b] = 1;
        }
        else if(a == 3)
        {
            paths[b][c] = 0;
            paths[c][b] = 0;
        }
    }
    for(int i = 0; i < outputS.size(); i++)
        cout << outputS[i];
    return 0;
}
