#include <iostream>
#include <sstream>

using namespace std;
bool p[1001][1001];
int n,m,q;
stringstream answers;
void read()
{
	cin>>n>>m;
	int a,b;
	for(int i=0;i<m;i++)
	{
		cin>>a>>b;
		p[a][b]=true;
		p[b][a]=true;
	}
}

void calculateRoutes()
{
	for(int i=1;i<=n;i++)
	{
		for(int j=1;j<=n;j++)
		{
			if(!p[i][j])
			{
				for(int k=1;k<=n;k++)
				{
					if((k!=i&&k!=j)&&(p[i][k]&&p[j][k]))
					{
						p[i][j]=true;
						p[j][i]=true;
					}
				}
			}
		}
	}
}

void displayRoutes()
{
	cout<<"   ";
	for(int i=1;i<=n;i++)
	cout<<i<<"  ";
	cout<<endl;
	for(int i=1;i<=n;i++)
	{
		cout<<i<<" |";
		for(int j=1;j<=n;j++)
		{
			cout<<p[i][j]<<"  ";
		}
		cout<<endl;
	}
}

void answerQuestions()
{
	cin>>q;
	int a,b;
	for(int i=0;i<q;i++)
	{
		cin>>a>>b;
		answers<<p[a][b];
	}
	string ans;
	answers>>ans;
	cout<<ans;
}

int main()
{
	read();
	calculateRoutes();
	//displayRoutes();
	answerQuestions();
	cout<<endl;
    return 0;
}
/*
9 9
1 2
3 4
5 6
7 8
9 5
7 2
8 2
6 9
1 7
3
1 8
6 2
4 7
*/
