#include<cstdio>
using namespace std;
struct edge
{
    int to,next,prev;
};
edge buf[200000];
int bufcnt=0;
int fedge[1020];
int rank[1020];
int par[1020];
int used[1020];
int n,m,q;
void u_merge(int a,int b)
{
    int apar=a;
    while(par[apar]!=-1) apar=par[apar];
    int bpar=b;
    while(par[bpar]!=-1) bpar=par[bpar];
    if(apar==bpar) return;
    if(rank[apar]==rank[bpar])
        rank[apar]++;
    else if(rank[apar]<rank[bpar])
    {
        bpar^=apar;apar^=bpar;bpar^=apar;
    }
    bpar=b;
    do{
       // printf("\ndbg par[%d]=%d\n",bpar,apar);
        b=par[bpar];
        par[bpar]=apar;
        bpar=b;
    }while(bpar!=-1);
    bpar=a;
    do{
     //   printf("\ndbg par[%d]=%d\n",bpar,apar);
        a=par[bpar];
        par[bpar]=apar;
        bpar=a;
    }while(bpar!=-1);
    par[apar]=-1;
    return;
}
int u_find(int a)
{
    while(par[a]!=-1) a=par[a];
    return a;
}
void u_ress()
{
    for(int i=0;i<1020;i++) {
        par[i]=-1;
        rank[i]=0;
    }
}
void add_edge(int a,int b)
{
    buf[bufcnt].to=b;
    buf[bufcnt].next=fedge[a];
    buf[bufcnt].prev=-1;
    if(fedge[a]!=-1) buf[fedge[a]].prev=bufcnt;
    fedge[a]=bufcnt++;
}
void rem_edge(int a,int k)
{
    if(buf[k].prev==-1) fedge[a]=buf[k].next;
    buf[buf[k].prev].next=buf[k].next;
    buf[buf[k].next].prev=buf[k].prev;
}
void DFS(int p,int v)
{
    used[v]=1;
    par[v]=p;
    for(int i=fedge[v];i!=-1;i=buf[i].next)
    if(!used[buf[i].to])
        DFS(p,buf[i].to);
}
int main()
{
    for(int i=0;i<1020;i++)
    {
        fedge[i]=-1;
        par[i]=-1;
    }
    scanf("%d%d",&n,&m);
    int a,b,c;
    for(int i=0;i<m;i++)
    {
        scanf("%d%d",&a,&b);
        add_edge(a,b);
        add_edge(b,a);
        u_merge(a,b);
    }
    scanf("%d",&q);
    for(int qq=0;qq<q;qq++)
    {
        scanf("%d%d%d",&c,&a,&b);
        if(c==1) if(u_find(a)==u_find(b)) printf("1"); else printf("0");
        if(c==2)
        {
            u_merge(a,b);
            add_edge(a,b);
            add_edge(b,a);
        }
        if(c==3)
        {
            for(int i=fedge[a];i!=-1;i=buf[i].next)
            if(buf[i].to==b)
            {
                rem_edge(a,i);
                rem_edge(b,i^1);
                break;
            }
            for(int i=0;i<=n;i++) used[i]=0;
            rank[a]=1;
            DFS(a,a);
            par[a]=-1;
            if(!used[b])
            DFS(b,b);
            rank[b]=1;
            par[b]=-1;
        }
    }
    printf("\n");
}
