#include<iostream>
#include<cstdio>
#include<algorithm>
#include<vector>
using namespace std;

struct data
{
    int pages;
    float pay;
    float payperpage;
};

data in[1000];
int n,m;
float maxpay;

bool findinvec( vector<int> vec, int a )
{
    for( int i = 0; i < vec.size(); i++)
    {
        if( vec[i] == a )
            return true;
    }
    return false;
}

void search(int v, int pagecount, vector<int> visited)
{
    if( pagecount + in[v].pages > m )
        return;
    if( pagecount + in[v].pages == m )
    {
        float sum = 0;
        for( int i = 0; i < visited.size(); i++ )
            sum+=in[visited[i]].pay;
        if( sum > maxpay )
            maxpay = sum;
        return;
    }
    pagecount+=in[v].pages;
    for( int i = 0; i < n; i++ )
    {
        if( !findinvec(visited, i) )
        {
            visited.push_back(i);
            search(i,pagecount,visited);
            visited.pop_back();
        }
    }
}

int main()
{
    scanf("%d%d", &n, &m);
    vector<int> v;
    for(int i = 0; i < n; i++)
    {
        scanf("%d%f", &in[i].pages, &in[i].pay);
        in[i].payperpage = in[i].pay/in[i].pages;
    }
    for( int i = 0; i < n; i++)
    {
        v.push_back(i);
        search( i, 0, v );
        v.pop_back();
    }
    cout<<maxpay<<endl;
    return 0;
}
