#include<cstdio>
#include<iostream>
#include<vector>
#define MAXN 1<<15
using namespace std;

int N, M, Q, keyy, used[MAXN];
vector <int> vec[MAXN];

void init (){
    int a, b;
    scanf ("%d %d",&N,&M);
    for (int i=0; i<M; i++){
        scanf ("%d %d",&a, &b);
        a--; b--;
        vec[a].push_back (b);
        vec[b].push_back (a);
    }
}

void DFS (int s, int p){
    if (s == p) {keyy = 1; return;}
    for (int i=0; i<vec[s].size();i++)
        if (!used[vec[s][i]])
        {
            used[vec[s][i]] = 1;
            DFS (vec[s][i], p);
            used[vec[s][i]] = 0;
        }
}

int main (){
    init ();
    int a, b;
    scanf ("%d",&Q);
    for (int i=0; i<Q; i++){
        scanf ("%d %d",&a,&b);
        a--; b--;
        keyy = 0;
        used[a] = 1;
        DFS (a, b);
        used[a] = 0;
        printf ("%d",keyy);
    }
    printf ("\n");
    return 0;
}
