#include<cstdio>
#include<queue>
#include<iostream>
using namespace std;

queue < pair<int, int > > q;

int n, m, k;
int vx, vy, matrix[4096][4096];

void init (){
    scanf ("%d %d",&n,&m);
    scanf ("%d",&k);
    for (int i=0; i<k; i++){
        scanf ("%d %d",&vx, &vy);
        vx--;vy--;
        q.push (make_pair (vx, vy));
        matrix[vx][vy] = 1;
    }
}

void bfs (){
    int maxlevel=0;
    while (!q.empty ()){
        int x = q.front().first;
        int y = q.front().second;
        q.pop ();
        if (matrix[x][y]>maxlevel) maxlevel = matrix[x][y];

        if (x+1 <n && matrix[x+1][y]==0) {q.push (make_pair(x+1, y)); matrix[x+1][y] = matrix[x][y]+1;}
        if (x-1>=0 && matrix[x-1][y]==0) {q.push (make_pair(x-1, y)); matrix[x-1][y] = matrix[x][y]+1;}
        if (y+1 <m && matrix[x][y+1]==0) {q.push (make_pair(x, y+1)); matrix[x][y+1] = matrix[x][y]+1;}
        if (y-1>=0 && matrix[x][y-1]==0) {q.push (make_pair(x, y-1)); matrix[x][y-1] = matrix[x][y]+1;}
    }/*
cout << endl << endl;
    for (int i=0; i<n; i++){
    for (int j=0; j<m; j++)
    cout << matrix[i][j]-1<< " ";
    cout << endl;
    }*/

    printf ("%d\n",maxlevel-1);
}

int main (){
    init ();
    bfs ();
    return 0;
}
