#include <iostream>
#include <stdint.h>
#include <math.h>

using namespace std;

bool check(uint32_t x, uint32_t p, bool odd, int t)
{
	uint32_t res = x*pow(10, t);
	
	if (odd)
		x /= 10;
		
	for (int i = t - 1; i >= 0; --i) {
		res += (x % 10)*pow(10, i);
		x /= 10;
	}
	
	return ((res % p) == 0);
}

uint32_t solve(int n, uint32_t p)
{
	bool odd = (bool)(n % 2);
	uint32_t count = 0;
	for (uint32_t x = pow(10,(n/2) - !odd); x < pow(10,((n/2) + 1 - !odd)); ++x)
		count += check(x, p, odd, n/2);
	
	if (1 == n)
		++count;	// bastards.
		
	return count;
}

int main()
{
	uint32_t p;
	int n;
	cin >> n >> p;
	cout << solve(n, p);
	return 0;
}
