#include<iostream>
#include<string>
#include<algorithm>
#include<map>
#include<vector>
#include<cstdio>
#include<cstdlib>
#include<cmath>

using namespace std;

int unis[1024];
int n,m;
bool rmd[1024][1024];

vector<int> v[1024];

int find(int a) {
    while(unis[a] != a) a = unis[a];
    return a;
}


void uni(int a, int b) {
    int s;
    s = find(a);
    unis[unis[b]] = s;
    unis[b] = s;
}
bool checkUni(int a,int b) {
    return find(a) == find(b);
}

void rebuildUnis(int aa, int bb) {
    int i, j;
    
    rmd[aa][bb] = true;
    rmd[bb][aa] = true;
    
    for( i = 1; i <= n; i++) unis[i] = i;
    for(i = 1; i <= n; i++)
        for(j = 0; j < v[i].size(); j++)
            if( !rmd[i][v[i][j]] ) 
                uni( i,v[i][j] );

}

void read() {
    int i, a, b, s, c;
    scanf("%d %d", &n, &m);
    for(i = 1; i <= n; i++) unis[i] = i;
    for(i = 0; i < m; i++) {
        scanf("%d %d", &a, &b);
        v[a].push_back( b );
        v[b].push_back( a );
        uni(a, b);
    }
    scanf("%d", &s);
    for( i = 0; i < s; i++) {
        scanf("%d %d %d", &a, &b, &c);
        if(a == 1) cout << checkUni(b, c);
        if(a == 2) {
            v[b].push_back( c );
            v[c].push_back( b );
            uni(b, c);
        }
        if(a == 3)
            rebuildUnis(b, c);
    }
    cout<<endl;
}

int main () {
    read();

    return 0;
}
