#include<iostream>
#include<string>
#include<algorithm>
#include<map>
#include<vector>
#include<cstdio>
#include<cstdlib>
#include<cmath>

using namespace std;

unsigned long long n, p, first, last;

void read() {
    cin >> n >> p;
}

unsigned long long getStartVal(bool fst = false,bool del = false) {
    unsigned long long s = fst ? 1 : 9, i;
    for(i = 1; i < n; i++) {
        if(  fst ) s *=10;
        else s = s*10 + 9;
    }
    if( del )
        while( s%p != 0 ) s++;
    return s;
}

bool isPal(unsigned long long s) {
    unsigned long long i =  first, j = 1;
    while(s / i % 10 == s / j % 10) {
        i /= 10;
        if(i == 0) break;
        j *= 10;
    }
    return  i ? false : true ;

}

void solve() {
    unsigned long long count = 0;
    unsigned long long curr;
    last = getStartVal();
    first = getStartVal( true );
    curr = getStartVal( true, true );
    if(p > last) 
    {
        if(n == 1) cout << 1 <<endl; 
        else cout << 0 <<endl; 
        return ;
    }
    while(curr <= last && curr >= first) {
        if(curr % p == 0) {
            if( isPal( curr ) ) {
                count++;
            }
        }
        curr += p;
    }
    if(n == 1) count++;
    cout <<count << endl;



}

int main () {

    read();
    solve();

    return 0;
}
