#include<iostream>
#include<cstdio>
#include<vector>
#include<queue>
using namespace std;

int n,m;
int p[1010],l[1010];
int a[1010][1010];
int used[1010];
vector<int> v[1010];

int bash(int x)
{
    if(p[x]==0)return x;
    else return bash(p[x]);
}

void svr(int k1,int k2)
{
    int p1=bash(k1),p2=bash(k2);
    if(p1==p2)return;
    if(l[p1]>l[p2])p[p2]=p1;
    else if(l[p1]<l[p2])p[p1]=p2;
    else {p[p2]=p1;l[p1]++;}
}

void bfs(int k)
{
    queue<int> q;
    q.push(k);
    used[k]=1;
    p[k]=0;
    l[k]=1;
    int tmp,i;
    while(!q.empty())
    {
        tmp=q.front();
        q.pop();
        for(i=0;i<v[tmp].size();i++)
        {
            if(a[tmp][v[tmp][i]]&&used[v[tmp][i]]==0)
            {
                used[v[tmp][i]]=1;
                p[v[tmp][i]]=k;
                q.push(v[tmp][i]);
            }
        }
    }
}

int main()
{
    int i,q,k1,k2;
    scanf("%d%d",&n,&m);
    for(i=0;i<m;i++)
    {
        scanf("%d%d",&k1,&k2);
        svr(k1,k2);
        v[k1].push_back(k2);
        v[k2].push_back(k1);
        a[k1][k2]=a[k2][k1]=1;
    }
    scanf("%d",&q);
    for(;q;q--)
    {
        scanf("%d%d%d",&i,&k1,&k2);
        if(i==1)
        {
            if(bash(k1)==bash(k2))printf("1");
            else printf("0");
        }
        else if(i==2){svr(k1,k2);a[k1][k2]=a[k2][k1]=1;v[k1].push_back(k2);v[k2].push_back(k1);}
        else if(i==3)
        {
            a[k1][k2]=a[k2][k1]=0;
            memset(used,0,sizeof(used));
            bfs(k1);
            if(used[k2]==0)bfs(k2);
        }
    }
    printf("\n");
}
