#include<iostream>
#include<cmath>
#include<algorithm>
#include<cstdio>
#include<queue>
#include<vector>
#include<map>

using namespace std;

queue<long long> q;
vector<long long>v[2048];

long long used[1024],n,m,k;

void bfs(long long x)
{
    long long p,i,sz;
    
    used[x]=x;
    q.push(x);
    
    while(!q.empty())
    {
        p=q.front();
        q.pop();
        sz=v[p].size();
        
        for(i=0;i<sz;i++)
        {
            if(!used[v[p][i]])
            {
                used[v[p][i]]=x;
                q.push(v[p][i]);
            }
        }
    }
}

void read()
{
    long long i,x,y;
    string s="";
    
    scanf("%lld%lld",&n,&m);
    
    for(i=0;i<m;i++)
    {
        scanf("%lld%lld",&x,&y);
        
        v[x].push_back(y);
        v[y].push_back(x);
    }
    
    for(i=1;i<=n;i++)
    if(!used[i])bfs(i);
    
    scanf("%lld",&k);
    
    for(i=0;i<k;i++)
    {
        scanf("%lld%lld",&x,&y);
        
        if(used[x]==used[y])printf("1");
        else printf("0");
    }
    
    printf("\n");
    
}

int main()
{
    read();
    return 0;
}
/*
9 9
1 2
3 4
5 6
7 8
9 5
7 2
8 2
6 9
1 7

3
1 8
6 2
4 7
*/
