#include <iostream>
#include <vector>

using namespace std;

class maper{
public:
    int map[700][700];
    int places;
    maper(int n){
        places = n;
        for(int i =0;i<n;i++){
            for(int j =0;j<n;j++){
                map[i][j] = 0;
            }
        }

    };

    void addCon(int from,int to);
    int checkCon(int from,int to);


};
vector<int> checked;

bool contains(int i){
    bool condition = false;
    for(int i = 0;i<checked.size();i++){
        if(checked[i] == i){
          condition = true;
          break;
        }
    }
    return condition;
}


int maper::checkCon(int from,int to){
    if(map[from - 1][to - 1] == 1 || map[to - 1][from - 1] == 1){
        return 1;
    }
   checked.push_back(from);
   for(int i =1;i<places;i++){
    if(map[i][from - 1] == 1 && !contains(i)){
        if(checkCon(i+1,to) == 1){
            return 1;
        }else{
            return 0;
        }
     }
   }
   return 0;
};
void maper::addCon(int from,int to){
    map[from -1][to - 1] = 1;
    map[to - 1][from - 1] = 1;

};


int main()
{
    int places;
    int cons;
    vector<int> connection1(10),connection2(10);
    int calls;
    vector<int> type(10);
    vector<int> cons1(10),cons2(10);


    cout<<"Places: ";
    cin>>places;
    cout<<"Connections: ";
    cin>>cons;
    cout<<"---------------------\n";
    for(int i =0;i<cons;i++){
        cin>>connection1[i]>>connection2[i];
    }
    cout<<"---------------------\n";
    cout<<"Calls: ";
    cin>>calls;
    cout<<"---------------------\n";
        for(int i =0;i<calls;i++){
        cin>>type[i]>>cons1[i]>>cons2[i];
    }
    maper theMap(places);

    for(int i = 0;i<cons;i++){
        theMap.addCon(connection1[i],connection2[i]);
    }

    for(int i =0;i<calls;i++){
        if(type[i] == 2){
            theMap.addCon(cons1[i],cons2[i]);
        }else if (type[i] == 1){
            checked.clear();
            cout<<theMap.checkCon(cons1[i],cons2[i]);
        }
    }

    return 0;

}

