#include <iostream>
#include <cmath>
#include <iomanip>
int main(){
    std::ios::sync_with_stdio(false);
    std::cin.tie(NULL);
    double a, b, c;
    std::cin>>a>>b>>c;
    if(b<a) std::swap(a, b);
    double lx=0, rx;
    if(c<a) rx=c;
    else rx=a;
    if(c>b) lx=sqrt(c*c-b*b);
    if(lx>rx){
        std::cout<<"0.00\n";
        return 0;
    }
    while(rx-lx>0.000001){
        double ly=sqrt(c*c-lx*lx);
        double ld=lx/ly - (b-ly)/(a-lx);
        double x=(rx+lx)/2.0;
        double y=sqrt(c*c-x*x);
        double d=x/y - (b-y)/(a-x); // We need to get this close to 0. Then it's a rectangle.
        if(d*ld<=0){ // Different signs. 0 between lx and x
            rx=x;
        }else{
            lx=x;
        }
    }
    double x=(lx+rx)/2;
    double y=sqrt(c*c-x*x);
    std::cout<<std::fixed<<std::setprecision(2)<<sqrt( (a-x)*(a-x) + (b-y)*(b-y) )<<'\n';
    return 0;
}
