#include <iostream>
#include <string>

using namespace std;
//Math.Pow
int polindromsMax=1024;
int polindroms[1024];
int currentPolindrom = 0;

int Length(string input)
{
    int length=0;
    while(input[length]!=0)
    {
        length++;
    }
    return length;
}


bool PolindromCheck(string number)
{
    int count=0;
    int length=Length(number);
    for(int i=0;i<length/2;i++)
    {
        if(number[i]==number[length-i-1])
            count++;
        else
            return false;
        if(count==length/2)
            return true;
    }
    return false;
}

string Reverse(string result)
{
    string tempResult;
    int length = Length(result);
    for(int i=length-1;i>=0;i--)
        tempResult+=result[i];
    return tempResult;
}

string ConvertToString(long long number)
{
    string result;
    while(number>0)
    {
        result+=(number%10+48);
        number -= ((number%10));
        number/=10;
    }
    result = Reverse(result);

    return result;
}

int Pow(int amount)
{
    int number=1;
    while(amount>0)
    {
        amount--;
        number*=10;
    }
    return number;
}
int GetPolindroms(int n, int p)
{
    long long numberMax, numberMin;
    numberMax=Pow(n+1)-1;
    numberMin=Pow(n)-1;
    while(numberMax>numberMin)
    {
        if(numberMax%p==0)
        {
            bool check = PolindromCheck(ConvertToString(numberMax));
            if(check)
            {
                polindroms[currentPolindrom]=true;
                currentPolindrom++;
            }
        }
        numberMax--;
    }
    return 0;
}
int main()
{
    int n;
    int p;
    cin>>n;
    cin>>p;
    GetPolindroms(n, p);
    int counter=0;
    for(int i=0; i<currentPolindrom;i++)
        if(polindroms[i] == 1)
            counter++;
    cout<<counter;
    return 0;
}
