#include <cstdio>

/*

5 8
2 10.20
3 13.42
1 15.12
4 21.23
2 9.45

*/

#define MAXN 1000
#define MAXM 1000

int N,M,P[MAXN],C[MAXN]; //P-pages C-credit
//C[i] < 100*100

int sol[MAXN+1][MAXM+1];

void solve()
{
	//just in case...
	for(int n=0; n<N; n++) sol[n][0] = 0;
	for(int m=0; m<=M; m++) sol[0][m] = 0;
	
	//O(N*M)
	for(int n=1; n<=N; n++)
		for(int m=0; m<=M; m++)
		{
			if(m >= P[n-1]) sol[n][m] = sol[n-1][m-P[n-1]] + C[n-1]; //if we take the book
			if(sol[n-1][m] > sol[n][m]) sol[n][m] = sol[n-1][m]; // if we leave the book
		}
}

int main()
{
	double c;
	scanf("%d %d", &N, &M);
	
	for(int i=0; i<N; i++)
	{
		scanf("%d %lf", &P[i], &c);
		C[i] = ((int)(c*100 + 0.1)); // "+ 0.1" - bug fixing powah
	}
	//cout << "\n";
	//for(int i=0; i<N; i++) cout << P[i] << " " << C[i] << "\n";
	
	solve();
	
	printf("%d.%d\n", sol[N][M]/100, sol[N][M]%100);
	
	return 0;
}
