#include <iostream>

using namespace std;

#define MAXDIG 10000

int N;

int a[MAXDIG],b[MAXDIG],t[MAXDIG];

void add() // adds A and B together into T
{
	//*a >= *b
	int x;
	*t = *a;
	t[1] = 0;
	for(int i=1; i<=*a; i++)
	{
		x = a[i];
		if(i <= *b) x += b[i];
		t[i] += x;
		if(t[i] > 9)
		{
			t[i] -= 10;
			t[i+1] = 1;
			if(i == *a) *t = *a+1;
		}
		else t[i+1] = 0;
	}
}

void init()
{
	*a=1; a[1]=2;
	*b=1; b[1]=1;
}

void solve()
{
	//O(N)
	for(int n=1; n<N; n++)
	{
		add(); //t=a+b
		for(int i=0; i<=*a; i++) b[i]=a[i]; //b=a
		for(int i=0; i<=*t; i++) a[i]=t[i]; //a=t
	}
}


int main()
{
	cin >> N;
	
	init();
	
	solve();
	
	for(int i=*b; i>=1; i--) cout << b[i];
	cout << " ";
	for(int i=*a; i>=1; i--) cout << a[i];
	cout << "\n";
	
	return 0;
}
