#include <iostream>
#include <string>

using namespace std;

string SumOfBigNumbers(string a, string b)
{
    int aSize = a.size(), bSize = b.size(), maxSize = aSize;
    if (bSize > maxSize) maxSize = bSize;
    string ret = "";
    ret.resize(maxSize, '0');
    bool plusOne = false;
    int i = aSize - 1, j = bSize - 1;
    maxSize--;
    do
    {
        int add = 0;
        if (i >= 0) add += a[i] - '0';
        if (j >= 0) add += b[j] - '0';
        ret[maxSize] = ((add + (int)plusOne) % 10) + '0';
        if (add >= 10) plusOne = true;
        else plusOne = false;
        maxSize--;
        i--;
        j--;
    }
    while ((i >= 0) || (j >= 0));
    if (plusOne) ret = "1" + ret;
    return ret;
}

int main()
{
    string a = "1", b = "2";
    int n;
    cin >> n;
    
    for (int i = 1; i < n; i++)
    {
        string c = SumOfBigNumbers(a, b);
        a = b;
        b = c;
    }
    
    cout << a << ' ' << b << endl;
    
    return 0;
}