#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>

#define pb push_back
#define mp make_pair

using namespace std;

typedef long long LL;

int n;
LL p;
LL ans;
LL pw[20];
LL num[20];

vector< LL > r;
pair<LL, int> vec[128];
int sz;

void read() {
    cin >> n >> p;
}

void go(int k) {
    if(k == (n + 1) / 2) {
        LL t = 0;
        for(int i = 0; i < k; i ++) {
            t += num[i] * pw[i];
            t += num[i] * pw[n - i - 1];
        }
        if(n % 2 == 1) t -= num[k - 1] * pw[k - 1];
        if(t % p == 0) ans ++;
        return;
    }

    int d = 0;
    if(!k) d ++;
    for(int i = d; i <= 9; i ++) {
        num[k] = i;
        go(k + 1);
    }
}

int bs(LL x) {
    int le = 0, ri = sz - 1, mid;
    while(le <= ri) {
        mid = (le + ri) >> 1;
        if(vec[mid].first == x) return vec[mid].second;
        if(vec[mid].first < x) le = mid + 1;
        else ri = mid - 1;
    }
    return 0;
}

void go2(int k) {
    if(k == 6) {
        LL t = 0;
        for(int i = 0; i <= 5; i ++) {
            t += num[i] * pw[i];
            t += num[i] * pw[n - i - 1];
        }
        t %= p;
        if(t) t = p - t;
        ans += bs(t);
        return;
    }

    int d = 0;
    if(!k) d ++;
    for(int i = d; i <= 9; i ++) {
        num[k] = i;
        go2(k + 1);
    }
}

int main()
{
    read();

    if(n == 1) {
        for(LL x = 0; x <= 9; x ++)
            if(x % p == 0)
                ans ++;
        cout << ans << endl;
        return 0;
    }

    pw[0] = 1LL;
    for(int i = 1; i <= n; i ++)
        pw[i] = pw[i - 1] * 10LL;

    if(n <= 14) {
        go(0);
        cout << ans << endl;
        return 0;
    }

    for(LL x = 0; x <= 9; x ++)
        for(LL y = 0; y <= 9; y ++)
            r.pb((x * pw[8] + y * pw[7] + x * pw[6]) % p);

    sort(r.begin(), r.end());

    for(int i = 0; i < r.size(); i ++)
        if(!sz || vec[sz - 1].first != r[i]) {
            int cnt = 0;
            for(int j = i; j < r.size(); j ++)
                if(r[i] == r[j])
                    cnt ++;
            vec[sz ++] = mp(r[i], cnt);
        }

    go2(0);

    cout << ans << endl;

    return 0;
}
