#include <iostream>
#include <vector>

using namespace std;

struct Child
{
    int startPos, endPos;
};

int main()
{
    int n, k, sum = 0, mushroomsTaken = 0;
    cin>>n>>k;

    Child children[n];
    vector<bool> mushrooms;

    for(int i = 0; i < n; i++)
    {
        int m;
        cin>>m;
        sum+=m;


        children[i].startPos = mushrooms.size();
        if(m==0)
        {
            mushrooms.push_back(false);
        }
        else
        {
            for(int j = 0; j < m; j++)
            {
                mushrooms.push_back(true);
            }
        }

        children[i].endPos = mushrooms.size() - 1;

    }

    int interval = sum/k;
    int counter = 0;

    for(int i = 0; i < mushrooms.size(); i++)
    {
        if(!mushrooms[i]) continue;
        counter++;
        if(counter == interval)
        {
            mushrooms[i]=false;
            mushroomsTaken++;
            if(mushroomsTaken==k) break;
            counter = 0;
        }
    }


    for(int i = 0; i < n; i++)
    {
        int m = 0;
        for(int start = children[i].startPos; start <= children[i].endPos; start++)
        {
            if(mushrooms[start]) m++;
        }
        cout<<m;
        if(i!=n-1) cout<<" ";
    }

    //main();
    return 0;
}
