#include <cstdio>
#include <queue>
#define MAXN 1007
using namespace std;

int n,m,q;
bool u[MAXN];
char r[50007];
int adj[MAXN][MAXN];

void init()
{
    for (int i=0;i<n;i++)
        u[i]=false;
}

void add(int x,int y)
{   adj[x][y]=adj[y][x]=1;  }

void rem(int x,int y)
{   adj[x][y]=adj[y][x]=0;  }

void inp()
{
    scanf("%d %d", &n, &m);
    for (int i=0;i<m;i++)
    {
        int x,y;
        scanf("%d %d", &x, &y);
        add(x-1,y-1);
    }
}

bool BFS(int x,int y)
{
    queue <int> qe;
    qe.push(x);
    u[x]=true;
    while (!qe.empty())
    {
        x=qe.front();
        qe.pop();
        if (x==y)
            return true;
        for (int i=0;i<n;i++)
            if (adj[x][i]&&!u[i])
            {
                qe.push(i);
                u[i]=true;
            }
    }
    
    return false;
}

void solve()
{
    int g=0;
    scanf("%d", &q);
    while (q--)
    {
        int c,x,y;
        scanf("%d %d %d", &c, &x, &y);
        if (c==1)
        {
            init();
            r[g++]=(int)BFS(x-1,y-1)+'0';
        }
        if (c==2)
            add(x-1,y-1);
        if (c==3)
            rem(x-1,y-1);
    }
    
    for (int i=0;i<g;i++)
        printf("%c", r[i]);
    printf("\n");
}

int main()
{
    inp();
    solve();
    return 0;
}