#include <iostream>
#include <string>
#define MAXN 2001
using namespace std;

int n, m;
long long q;
int A[MAXN][MAXN];
int value = 2;
int used[MAXN];
int result[MAXN];

void DFS(int i)
{
    used[i] = 1;
    result[i] = value;
    for(int j = 1; j<=n; j++)
    {
        if(A[i][j] != 0 && used[j] == 0)
        {
            DFS(j);
        }
    }
}

int main()
{
    int res[MAXN];
    int resIndex = 0;
    cin >> n >> m;
    for(int i = 1; i<=m; i++)
    {
        int s, p;
        cin >> s >> p;
        A[s][p] = 1;
        A[p][s] = 1;
    }
    for(int i = 1; i<=n; i++)
    {
        if(used[i] == 0)
        {
            DFS(i);
            value++;
        }
    }
    cin >> q;
    for(long long i = 1; i<=q; i++)
    {
        int s, p, w;
        cin >> s >> p >> w;
        if(s == 1)
        {
            if(result[p] == result[w])
            {
                res[resIndex] = 1;
                resIndex++;
            }
            else
            {
                res[resIndex] = 0;
                resIndex++;
            }
        }
        else
        {
            if(result[p] != result[w])
            {
                for(int i = 1; i<=n; i++)
                {
                    if(result[i] == result[p] && p != i)
                    {
                        result[i] = result[w];
                    }
                }
                result[p] = result[w];
            }
        }
    }
    for(int i = 0; i<resIndex; i++)
    {
        cout << res[i];
    }
    cout << endl;
//    for(int i  = 1; i<=n; i++)
//    {
//        cout << result[i] << " ";
//
//    }

}

