#include <cstdio>
#include <string>

using namespace std;

int n;
long long p;

void Input()
{
    scanf("%d%lld", &n, &p);
    //printf("%d %lld\n", n, p);
}

string ToString(long long number)
{
    string r = "";
    
    while (number > 0)
    {
        long long d = number % 10;
        r += (char)(d + '0');
        number /= 10;
    }
    
    string normalStr = "";
    
    if ((n & 1) > 0)
    {
        for (int i = r.length() - 1; i > 0; i--)
        {
            normalStr += r[i];
        }
    }
    else
    {
        for (int i = r.length() - 1; i >= 0; i--)
        {
            normalStr += r[i];
        }
    }
    
    return normalStr + r;
}

long long ToNumber(string str)
{
    long long r = 0;
    
    for (int i = 0; i < str.length(); i++)
    {
        r *= 10;
        r += str[i] - '0';
    }
    
    return r;
}

void GeneratePalindromes(int s)
{
    long long numSize = 1;
    
    for (int i = 1; i < s; i++)
    {
        numSize *= 10;
    }
    
    //printf("%d\n", numSize);
    
    long long maxNumSize = numSize * 10;
    long long cnt = 0;
    for (long long i = numSize; i < maxNumSize; i++)
    {
        string r = ToString(i);
       // cout << r << endl;
        long long res = ToNumber(r);
        if (res % p == 0)
        {
            //printf("%lld ", res);
            cnt++;
        }
    }
    
    printf("%lld\n", cnt);
}

int GetNumberLength(long long number)
{
    int cnt = 0;
    
    while (number > 0)
    {
        number /= 10;
        cnt++;
    }
    
    return cnt;
}

int main()
{
    Input();
    int pLength = GetNumberLength(p);
    if (pLength > n)
    {
        printf("0\n");
    }
    else
    {
        int s = (n + 1) / 2;
//    printf("%d %d\n", n, s);
        GeneratePalindromes(s);
    }
    return 0;
}