#include<cstdio>
#include<queue>
#include<cstring>
#include<string>
using namespace std;

int A[1010][1010];

int n,m,query;

int used[1010];

bool BFS(int start, int end)
{
    queue<int>q;
    q.push(start);
    used[start] = 1;
    while(!q.empty())
    {
        int node = q.front();
        q.pop();
        if(node == end)
            return 1;
        for(int i = 0; i <= n; i++)
        {
            if(A[node][i] == 1 && used[i] == 0)
            {
                q.push(i);
                used[i] = 1;
            }
        }
    }
    return 0;
}

void Init()
{
    string s;
    scanf("%d %d",&n,&m);
    for(int i = 0 ; i < m; i++)
    {
        int u,v;
        scanf("%d %d",&u,&v);
        A[u][v] = 1;
        A[v][u] = 1;
    }
    scanf("%d",&query);
    for(int i = 0; i < query; i++)
    {
        int t,u,v;
        scanf("%d %d %d",&t,&u,&v);
        if(t == 1)
        {
            if(BFS(u,v))
            s.push_back('1');
            else
            s.push_back('0');
            memset(used,0,sizeof(int)*1010);
        }
        if(t == 2)
        {
            A[u][v] = 1;
            A[v][u] = 1;
        }
        if(t == 3)
        {
            A[v][u] = 0;
            A[u][v] = 0;
        } 
        
    }
    for(int i = 0 ; i < s.size(); i++)
        printf("%c",s[i]);
}

int main()
{
    Init();
    printf("\n");
    return 0;
}
