#include <iostream>
#include <cmath>
using namespace std;
int n;
int fRes;
long long p;
long long minL, maxL;

bool checkPalindrome(long long num)
{
    long long rev = 0;
    long long temp = num;
    while (temp > 0)
    {
        rev = (rev * 10) + (temp % 10);
        temp /= 10;
    }

    if(num == rev) return true;
    return false;
}

int main()
{
    cin >> n >> p;
    minL = pow(10, n-1);
    maxL = 0;
    fRes = 0;
    for(int i = 1; i <= n; i++)
    {
        maxL += 9*pow(10, i-1);
    }
    long long current = p;
    while(current <= maxL)
    {
        if(current >= minL)
        {
            if(checkPalindrome(current))
            {
                fRes++;
            }
        }
        current += p;
    }
    cout << fRes;
    return 0;
}
