#include<iostream>
#include<cstdio>
#include<algorithm>
#include<queue>
using namespace std;
long long n,m,x,y,nei[1001][1001],mn[1001],t,p,used[1001];
queue<long long> q;
void unite(int pos1, int pos2)
{
    int p=mn[pos2];
    for(int i=1; i<=n; i++) if(mn[i]==p) mn[i]=mn[pos1];
}
bool way(int s, int f)
{
    while(!q.empty()) q.pop();
    q.push(s);
    for(int i=1; i<=n; i++) used[i]=0;
    used[s]=1;
    while(!q.empty())
    {
        int x=q.front();
        q.pop();
        for(int i=1; i<=n; i++)
        {
            if(nei[x][i]==1&&used[i]==0) {if(i==f) return true; q.push(i); used[i]=1;}
        }
    }
    return false;
}
void bfs(int s, int b)
{
    while(!q.empty()) q.pop();
    for(int i=1; i<=n; i++) used[i]=0;
    q.push(s);
    used[s]=1;
    mn[s]=b;
    while(!q.empty())
    {
        int x=q.front();
        q.pop();
        for(int i=1; i<=n; i++)
        {
            if(nei[x][i]==1&&used[i]==0) {q.push(i); used[i]=1; mn[i]=b;}
        }
    }

}
void divide(int pos1, int pos2)
{
    int k=mn[pos2];
    if(pos1==k)
    {
        bfs(pos2,pos2);
    }
    else
    {
        bfs(pos1,pos1);
        for(int i=1; i<=n; i++) if(mn[i]==k) mn[i]=pos2;
    }
}
int main()
{
    scanf("%lld%lld",&n,&m);
    for(int i=1; i<=m; i++)
    {
        scanf("%lld%lld",&x,&y);
        nei[x][y]=nei[y][x]=1;
    }
    for(int i=1; i<=n; i++)
    {
        if(mn[i]==0) bfs(i,i);
    }
    scanf("%lld",&t);
    for(int i=1; i<=t; i++)
    {
        scanf("%lld%lld%lld",&p,&x,&y);
        if(p==1)
            printf("%d",mn[x]==mn[y]);
        else if(p==2)
        {
            nei[x][y]=nei[y][x]=1;
            if(mn[x]!=mn[y]) unite(x,y);
        }
        else
        {
            nei[x][y]=nei[y][x]=0;
            if(way(x,y)==1) continue;
            else divide(x,y);
        }
    }
    printf("\n");
	return 0;
}
