#include <iostream>
#include <cstdio>
#include <vector>
using namespace std;
int par[1024], n, m, q;
bool conn[1024][1024];
vector<int> v[1024];
int find(int pos){
    while(pos != par[pos])
        pos = par[pos];
    return pos;
}
bool push(int pos, int val){
    while(pos != par[pos]){
        int t = par[pos];
        par[pos] = val;
        pos = t;
    }
    par[pos] = val;
}
bool change(int x){
    int q = find(x);
    for(int i = 0; i < v[x].size() ; i++)
       if(conn[v[x][i]][x]){
           push(v[x][i], q);
       }
}
int main ()
{
    scanf("%d%d", &n, &m);
    for(int i = 1; i <= n; i++)
        par[i] = i;
    for(int i = 1; i <= m; i++){
        int x, y;
        scanf("%d%d", &x, &y);
        conn[x][y] = conn[y][x] = 1;
        int q = find(y);
        push(x, q); push(y, q);
        v[x].push_back(y);
        v[y].push_back(x);
    }
    scanf("%d", &q);
    for(; q > 0; q--){
        int p, x, y;
        scanf("%d%d%d", &p, &x, &y);
        if(p == 1) printf("%d", (find(x) == find(y)));
        else if(p == 2) {
            int q = find(y);
            conn[x][y] = conn[y][x] = 1;
            push(x, q); push(y, q);
            v[x].push_back(y);
            v[y].push_back(x);
        }
        else {
            conn[x][y] = conn[y][x] = 0;
            if(find(x) != find(y)) continue;
            par[x] = x;
            par[y] = y;
            for(int i = 0; i < v[x].size() ; i++)
                if(conn[v[x][i]][x]){
                    par[v[x][i]] = x;
                    change(v[x][i]);
                }
            for(int i = 0; i < v[y].size() ; i++)
                if(conn[v[y][i]][y]){
                    par[v[y][i]] = y;
                    change(v[y][i]);
                }
        }
    }
    printf("\n");
    return 0;
}
