#include <cstdio>
#include <cmath>

#define EPS 0.0001

using namespace std;

double a,b,c;

inline double parabola(const double &x)
{
    return 2*x*x - b*x - c*c;
}

inline double insane(const double &x)
{
    return -a*sqrt(c*c-x*x);
}

inline double fabbs(const double &x)
{
    if ( x < 0 ) return -x;
    return x;
}

int main()
{
        double x,d,l,r,mid,maxd;
        int aa,bb,cc;
        scanf ("%d%d%d",&aa,&bb,&cc);
        a = (double)aa;
        b = (double)bb;
        c = (double)cc;

        maxd = a;

       // if ( bb >= 2*cc )
        //{
            l = 0;
            r = c;
            while ( r - l > 0.0000000001 )
            {
                mid = (l+r)/2;
                if ( insane(mid) < parabola(mid) ) l = mid;
                else r = mid;
            }

            if ( fabbs ( insane(l) - parabola(l) ) < EPS )
            {
                x = l;
                d = ( ( a - sqrt(c*c-x*x) ) * c ) / x;
                if ( d > maxd ) maxd = d;
            }
       // }

        printf ("%.2lf\n",maxd);
}
