#include <iostream>
#include <cstdio>
#include <queue>
using namespace std;
int n,m,k,x,y;
int used[3300][3300];
queue<int>q;

void read()
{
    int t,r;
    scanf("%d %d",&n,&m);
    scanf("%d",&k);
    for (int i=0; i<k; i++)
    {
        scanf("%d %d",&t,&r);
        t--;
        r--;
        q.push(t);
        q.push(r);
        used[t][r]=1;
    }
}

void sol()
{
    while (!q.empty())
    {
        x=q.front();
        q.pop();
        y=q.front();
        q.pop();
        if (x-1>=0)
            if (used[x-1][y]==0)
            {
                used[x-1][y]=used[x][y]+1;
                q.push(x-1);
                q.push(y);
            }
        if (y+1<m)
            if (used[x][y+1]==0)
            {
                used[x][y+1]=used[x][y]+1;
                q.push(x);
                q.push(y+1);
            }
        if (x+1<n)
            if (used[x+1][y]==0)
            {
                used[x+1][y]=used[x][y]+1;
                q.push(x+1);
                q.push(y);
            }
        if (y-1>=0)
            if (used[x][y-1]==0)
            {
                used[x][y-1]=used[x][y]+1;
                q.push(x);
                q.push(y-1);
            }
    }
    for (int i=0; i<n; i++)
    {
        for (int j=0; j<m; j++)
        {
            cout<<used[i][j]<<" ";
        }
        cout<<endl;
    }
    printf("%d\n",used[x][y]-1);
}


int main ()
{
    read();
    sol();
    return 0;
}
