#include <iostream>
#include <cstdio>
#include <cmath>
using namespace std;

double a,b,c;

double evaluate(double x)
{
       double y=sqrt(c*c-x*x);
       
       double toc=sqrt((a-x)*(a-x)+b*b);
       double calph=(a-x)/toc;
       if(y/c<calph) return 0.0;
       
       double res=c*(a-x)/y;
       
       double bb=sqrt(res*res-(a-x)*(a-x));
       if(bb+y>b+0.01) return 0;
       
       return res;
}

int main()
{   
    scanf("%lf%lf%lf", &a, &b, &c);
    
    double res=0.0, current;
    
    double bestx;
    /*
    for(double x=0.00; x<=c; x+=0.001)
    {
               current=evaluate(x);
               if(current>res) {
                               //cout << "YES\n";
                               //cout << x << ' ' << sqrt(c*c-x*x) << ' ' << current << endl;
                               //system("pause");
                               res=current;
                               bestx=x;
                               }
    }*/
    
    double l=0.00000001, r=c;
    
    do
    {
           double mid=(l+r)/2;
           current=evaluate(mid);
           //cout << mid << ' ' << current << endl;
           if(current>res){
                           l=mid+0.00000001;
                           res=current;
                           }
           else r=mid-0.00000001;
    }
    while(l+0.00000001<r);
    
    
    printf("%.2lf\n", max(a,res));
    
    return 0;
}
