#include <iostream>
#include <vector>
using namespace std;

int n,m;
int id[1024];
vector<int> g[1024];
bool A[1024][1024];
bool used[1024];

void dfs(int v, int k)
{
     used[v]=1;
     id[v]=k;
     for(int i=0; i<g[v].size(); i++)
     {
             if(!used[g[v][i]] && A[v][g[v][i]]==1){
                               dfs(g[v][i],k);
             }
     }
}

int f(int x)
{
    while(x!=id[x])
    {
                   id[x]=id[id[x]];
                   x=id[x];
    }
    return id[x];
}

void unite(int x, int y)
{
     x=f(x); y=f(y);
     id[x]=id[y];
}

int main()
{
    int n,m;
    scanf("%d%d", &n, &m);
    
    for(int i=1; i<=n; i++) id[i]=i;
    
    int cmd,a,b;
    
    for(int i=0; i<m; i++)
    {
            scanf("%d%d", &a, &b);
            A[a][b]=1; A[b][a]=1;
            g[a].push_back(b);
            g[b].push_back(a);
            if(f(a)!=f(b))
            {
                                unite(a,b);
            }
    }
    
    int ca, cb;
    
    string s="";
    int q;
    cin >> q;
    for(int i=0; i<q; i++)
    {
            scanf("%d%d%d", &cmd, &a, &b);
            
            if(cmd==1){
                       ca=f(a);
                       cb=f(b);
                       if(ca==cb){ s+='1'; 
                       //cout << "YES\n"; 
                       }
                       else{ 
                             s+='0';
                            // cout << "NO\n";
                       }
            }
            else if(cmd==2)
            {
                 A[a][b]=1; A[b][a]=1;
                 g[a].push_back(b);
                 g[b].push_back(a);
                 if(f(a)!=f(b))
                 {
                                unite(a,b);
                 }
            }
            else {
                 for(int i=1; i<=n; i++) used[i]=0;
                 
                 A[a][b]=0; A[b][a]=0;
                 
                 for(int i=1; i<=n; i++)
                 {
                         if(!used[i]) dfs(i,i);
                 }
                 //for(int i=1; i<=n; i++) cout << id[i] << ' ';
                //cout << endl;
            }
    }
    
    cout << s << endl;
    return 0;
}
                       
