//Code by : PockaTa
//A&B School

#include<iostream>
#include<cstdio>
#include<algorithm>
#include<cmath>
#include<string>
#include<vector>
#include<queue>
#include<stack>
#include<cstring>
using namespace std;

int no[1024][1024],used[1024],n,m,q;

void serv_update( int a, int b )
{
    no[a][b]=1;
    no[b][a]=1;
}

void cust_update( int a, int b)
{
    no[a][b]=0;
    no[b][a]=0;
}

void dfs( int x )
{
    used[x]=1;
    
    for( int i=1; i<=n; i++)
    {
        if( no[x][i]==1 && !used[i] )
        dfs(i);
    }
}

void read()
{
    int a,b,c;
    
    scanf( "%d%d", &n,&m);
    for( int i=0; i<m; i++)
    {
        scanf( "%d%d", &a,&b);
        no[a][b]=1;
        no[b][a]=1;
    }
    
    scanf( "%d", &q );
    for( int i=0; i<q; i++)
    {
        scanf("%d%d%d", &a,&b,&c);
        if( a==1 )
        {
            dfs(b);
            if(used[c]==1) cout<<1;
            else cout<<0;
            memset(used,0,sizeof(used));
        }
        else if( a==2 )
            serv_update(b,c);
        else
            cust_update(b,c);
    }
}

int main()
{
    read();
    
    return 0;
}