#include <iostream>
typedef unsigned long long u64;
u64 calcMul(size_t n, u64 p, u64 *carry){
    u64 pow[16], mul[8], imul[8];
    pow[0]=1;
    for(size_t i=0;i<n;i++) pow[i+1]=pow[i]*10;
    for(size_t i=0;i<n/2;i++) mul[i]=(pow[i]+pow[n-i-1])%p;
    if(n%2==1) mul[n/2]=pow[n/2]%p;
    for(size_t i=0;i<(n+1)/2;i++) imul[i]=9*(p-mul[i])%p;
    carry[(n-1)/2]=0;
    for(size_t i=(n-1)/2;i--;) carry[i]=carry[i+1]+imul[i+1];
    for(size_t i=(n+1)/2;i--;) carry[i]=(carry[i]+mul[i])%p;
    return mul[0];
}
int main(){
    u64 p, mod, carry[8];
    size_t dig[8]={1,0,0,0,0,0,0,0}, count, n;
    std::cin>>n>>p;
    count=n==1;
    mod=calcMul(n, p, carry);
    n=(n+1)/2;
    while(true){
        if(mod>=p){
            mod-=p;
            count+=mod==0;
        }
        size_t i;
        for(i=n;i--;){
            dig[i]++;
            if(dig[i]!=10) break;
            dig[i]=0;
            if(i==0){
                std::cout<<count<<'\n';
                return 0;
            }
        }
        mod+=carry[i];
    }
    return 0;
}
