#include <iostream>
#include <string>

using namespace std;

bool villagePath[1024][2048] {0};
//Math.Pow
int Pow(int amount)
{
    int number=1;
    while(amount>0)
    {
        amount--;
        number*=10;
    }
    return number;
}
//string.Length
int Length(string input)
{
    int length=0;
    while(input[length]!=0)
    {
        length++;
    }
    return length;
}
//INT.PARSE
int GetNumber(string input)
{
    int number=0;
    int length=Length(input);
    for(int i=0;i<length;i++)
    {
        int tens= Pow(length-i-1);
        number += (input[i]-48)*tens;
    }
    return number;
}

//CreateTREE
void Tree(int i, int j, int M)
{
    for(int k=1; k<M;k++)
    {
        if(villagePath[j][k])
        {
           villagePath[i][k]=true;
           villagePath[k][i]=true;
           villagePath[k][j]=true;
        }
    }
}
//DestroyTree
void DTree(int i, int j, int M)
{
    for(int k=1; k<M;k++)
    {
        if(!villagePath[j][k])
        {
           villagePath[i][k]=false;
           villagePath[k][i]=false;
           villagePath[k][j]=false;
        }
    }
}

int main()
{
    int N,M;
    cin>>N;
    cin>>M;

    N++;
    M++;

    //SetData
    for(int i=1;i<M;i++)
    {
        int village;
        int link;
        cin>>village;
        cin>>link;
        villagePath[village][link] = true;
    }
    //MakeTree
        for(int i=1;i<N;i++)
        {
            for (int j=1;j<M;j++)
            {
                if(villagePath[i][j])
                {
                    Tree(i, j, M);
                }
                if(villagePath[i][j])
                    villagePath[j][i]=true;
            }
        }
    int Q;
    cin>>Q;
    string result="";

    for(int i=0;i<Q;i++)
    {
        int code;
        int village;
        int link;
        cin>>code;
        cin>>village;
        cin>>link;

        if(code==3)
        {
            villagePath[village][link]=false;
            for(int i=1;i<N;i++)
            {
                for (int j=1;j<M;j++)
                {
                    if(villagePath[i][j])
                    {
                        DTree(i, j, M);
                    }
                    if(villagePath[i][j])
                        villagePath[j][i]=false;
                }
            }
        }
        if(code==2)
        {
            villagePath[village][link]=true;
            for(int i=1;i<N;i++)
            {
                for (int j=1;j<M;j++)
                {
                    if(villagePath[i][j])
                    {
                        Tree(i, j, M);
                    }
                    if(villagePath[i][j])
                        villagePath[j][i]=true;
                }
            }
        }

        if(code==1)
            if(villagePath[village][link])
                result+='1';
            else
                result+='0';
    }

    cout<<endl;
    for(int i=0;i<N;i++)
    {
        for(int j=0;j<M;j++)
        {
            if(villagePath[i][j])
                cout<<i<<" "<<j<<" "<<villagePath[i][j]<<endl;
        }
    }
    cout<<endl;
    cout<<result<<endl;

    return 0;
}
