#include <cstdio>
#include <vector>
using namespace std;

int n,m,q;
int code,from,to;
int comp[1024],cpnum;
vector<int> roads[1024];

void read()
{
    scanf("%d%d", &n, &m);
    int fr,t;
    for (int i=0;i<m;i++) {
        scanf("%d%d", &fr, &t);
        roads[fr].push_back(t);
        roads[t].push_back(fr);
    }
    scanf("%d", &q);
    scanf("%d%d%d", &code, &from, &to);
    --q;
    while (code != 1 && q!=0) {
        if (code==2) {
            roads[from].push_back(to);
            roads[to].push_back(from);
        }
        if (code==3) {
            for (int i=0;i<roads[from].size();i++) {
                if (roads[from][i]==to) { roads[from][i]=from; }
            }
            for (int i=0;i<roads[to].size();i++) {
                if (roads[to][i]==from) { roads[to][i]=to; }
            }
        }
        scanf("%d%d%d", &code, &from, &to);
        --q;
    }
}

void dfs(int d)
{
    comp[d]=cpnum;
    for (int i=0;i<roads[d].size();i++) {
        if (comp[roads[d][i]]==0) { dfs(roads[d][i]); }
    }
}

void solve()
{
    for (int i=1;i<=n;i++) {
        comp[i]=0;
    }
    cpnum=0;
    for (int i=1;i<=n;i++) {
        if (comp[i]==0) {
            ++cpnum;
            dfs(i);
        }
    }
    int tmp;
    while(q>=0) {
        if (code==1) {
            if (comp[from]==comp[to]) { printf("1"); }
            else { printf("0"); }
        }
        else if (code==2) {
            roads[from].push_back(to);
            roads[to].push_back(from);
            tmp=comp[to];
            for (int i=1;i<=n;i++) {
                if (comp[i]==tmp) { comp[i]=comp[from]; }
            }
        }
        else if (code==3) {
            for (int i=0;i<roads[from].size();i++) {
                if (roads[from][i]==to) { roads[from][i]=from; }
            }
            for (int i=0;i<roads[to].size();i++) {
                if (roads[to][i]==from) { roads[to][i]=to; }
            }
            for (int i=1;i<=n;i++) {
                comp[i]=0;
            }
            cpnum=0;
            for (int i=1;i<=n;i++) {
                if (comp[i]==0) {
                    ++cpnum;
                    dfs(i);
                }
            }
        }
        if (q==0) { break; }
        scanf("%d%d%d", &code, &from, &to);
        --q;
    }
    printf("\n");
}

int main()
{
    read();
    solve();
    return 0;
}
