#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <queue>
#include <string>

using namespace std;

const int MAXN = (1 << 10);
bool b[MAXN][MAXN];
int n, m, q;
string ans;
bool used[MAXN];
int qq, X, Y;
int x, y;
bool ok;

void dfs (int g) {
    if (g == Y) {
        ok = 1;
        return ;
    }
    used[g] = 1;
    for (int i = 1; i <= n; ++ i)
        if (b[g][i] == 1 && used[i] == 0)
            dfs (i);
    return ;
}

void scan () {
    scanf ("%d %d", &n, &m);
    for (int i = 1; i <= m; ++ i) {
        scanf ("%d %d", &x, &y);
        b[x][y] = 1;
        b[y][x] = 1;
    }
}

void solve () {
    ans = "";
    scanf ("%d", &q);
    for (int i = 1; i <= q; ++ i) {
        scanf ("%d %d %d", &qq, &X, &Y);
        if (qq == 2) {
            b[X][Y] = 1;
            b[Y][X] = 1;
        }
        if (qq == 3) {
            b[X][Y] = 0;
            b[Y][X] = 0;
        }
        if (qq == 1) {
            for (int i = 1; i <= n; ++ i) used[i] = 0;
            ok = 0;
            dfs (X);
            if (ok == 1) ans = ans + '1';
            else ans = ans + '0';
        }
    }
    cout << ans << endl;
}

int main () {
    scan ();
    solve ();

    return 0;
}

/**
9 8
1 2
3 4
5 6
7 8
9 5
7 2
8 2
6 9
**/
