#include <cstdio>
#include <vector>
#define maxn 1010
#define maxQ 100010
#define mark printf("!\n");


using namespace std;

int curreg, regnum;
bool used[maxn];
int usedreg[maxn];
int R[maxn][maxn];
int posible;
int n, m , Q, quest;
int matrix[maxn][maxn];


struct Tcity{
	int region;
	vector <int> next;
};

Tcity A[maxn];

char ans[maxQ];
int ansnum;



void dfs(int s, int comp){

	used[s] = true;
	A[s].region = comp;

	for(int i = 0; i < A[s].next.size(); ++i){
		if(!used[ A[s].next[i] ] ){//printf("M = %d\n", matrix[s][A[s].next[i]]);
			if(matrix[s][A[s].next[i]]){
				dfs(A[s].next[i], comp);
			}else A[A[s].next[i]].region = -1;
		}
	}
}

void link(int s, int e){//printf("link\n");
	A[s].next.push_back(e);
	A[e].next.push_back(s);
	matrix[e][s] = matrix[s][e] = 1;

	if(A[s].region != A[e].region){
		R[A[s].region][A[e].region] = R[A[e].region][A[s].region] = 1;
	}
}

void dfsonreg(int s, int e, int regnum){//printf("s = %d, e = %d, regnum = %d, posible = %d\n", s, e, regnum, posible);
	usedreg[s] = 1;

	//printf("in %d\n", s);

	if(s == e)posible = 1;

	for(int i = 0; i<regnum && !posible; ++i){//printf("R[%d][%d] == %d, usedreg = %d, posible = %d\n", s, i, R[s][i], usedreg[i], posible);
		if( ( R[s][i] && !usedreg[i]) && !posible){
			dfsonreg(i, e, regnum);
		}
	}
}

void remove(int s, int e){
	matrix[s][e] = 0;
	matrix[e][s] = 0;
}


char check(int s, int e){
	if(A[s].region == A[e].region) return '1';

	posible = 0;
	//printf("%d test posible\n", posible);

	for(int i = 0; i<=regnum; ++i){
		usedreg[i] = 0;
	}

	dfsonreg(A[s].region, A[e].region, regnum);
	if(posible) return '1';
	else return '0';
}


int main()
{

	scanf("%d %d", &n, &m);
	int t1, t2;

	for(int i = 0; i<m; ++i){
		scanf("%d %d", &t1, &t2);
		--t1;
		--t2;
		A[t1].next.push_back(t2);
		A[t2].next.push_back(t1);
		matrix[t1][t2] = matrix[t2][t1] = 1;
	}

	int curreg = 0;

	for(int i = 0; i<n; ++i){
		if(!used[i]){
			dfs(i, curreg);
			curreg++;
		}

	}

	regnum = curreg;

	scanf("%d", &Q);

	for(int i = 0; i<Q; ++i){

		scanf("%d %d %d", &quest, &t1, &t2);
		--t1;
		--t2;

		if(quest == 1){
			ans[ansnum++] = check(t1, t2);
		}

		else if(quest == 2){
			 link( t1, t2);

			 /*for(int j = 0; j<regnum; ++j){
			 	for(int k = 0; k<regnum; ++k){
			 		printf("%d ", R[j][k]);
			 	}printf("\n");
			 }*/
		}

		else {//quest == 3

			for(int i = 0; i<n; ++i){
				used[i] = 0;
			}

			curreg = 0;

			remove(t1, t2);

			/*for(int j = 0; j<n; ++j){
			 	for(int k = 0; k<n; ++k){
			 		printf("%d ", matrix[j][k]);
			 	}printf("\n");
			 }*/

			 for(int j = 0; j<regnum; ++j){
			 	for(int k = 0; k<regnum; ++k){
			 		R[j][k] = 0;
			 	}
			 }

			for(int i = 0; i<n; ++i){
				if(!used[i]) dfs(i, curreg++);
			}

			regnum = curreg;//printf("regnum = %d\n", regnum);
		}
	}


	//for(int i = 0; i<ansnum; ++i)printf("%c ", ans[i]);
	ans[ansnum] = '\0';
	printf("%s\n", ans);







	return 0;
}
