#include <iostream>
#include <vector>
#include <queue>
using namespace std;

bool bUsed[2002], bMatrix[2002][2002], bUsedAtAll[2002];

int main () {
    int iPlaces, iRoads, iFrom, iTo, iCallings, iAskFrom, iAskTo, iCurrPlace, iNextPlace;
    cin >> iPlaces >> iRoads;
    vector < vector <int> > viNeighbours(iPlaces);
    queue <int> qiNextNeighbour;
    for (int i = 0; i < iRoads; ++ i)
    {
        cin >> iFrom >> iTo;
        viNeighbours[iFrom - 1].push_back(iTo - 1);
        viNeighbours[iTo - 1].push_back(iFrom - 1);
    }
    cin >> iCallings;
    vector <bool> bResult;
    for (int i = 0; i < iCallings; ++ i)
    {
        cin >> iAskFrom >> iAskTo;
        -- iAskFrom;
        -- iAskTo;
        if ((bUsedAtAll[iAskFrom] || bUsedAtAll[iAskTo]) && bMatrix[iAskFrom][iAskTo])
        {
            bResult.push_back(1);
            continue;
        }
        qiNextNeighbour.push(iAskFrom);
        iCurrPlace = iAskFrom;
        bUsed[iAskFrom] = 1;
        bUsedAtAll[iAskFrom] = 1;
        iNextPlace = 0;
        while (!qiNextNeighbour.empty())
        {
            if (iNextPlace < viNeighbours[iCurrPlace].size())
            {
                if (!bUsed[viNeighbours[iCurrPlace][iNextPlace]])
                {
                    qiNextNeighbour.push(viNeighbours[iCurrPlace][iNextPlace]);
                    bUsed[viNeighbours[iCurrPlace][iNextPlace]] = 1;
                    bUsedAtAll[viNeighbours[iCurrPlace][iNextPlace]] = 1;
                    if (viNeighbours[iCurrPlace][iNextPlace] == iAskTo)
                        while (!qiNextNeighbour.empty())
                            qiNextNeighbour.pop();
                }
                ++ iNextPlace;
            } else
            {
                qiNextNeighbour.pop ();
                if (!qiNextNeighbour.empty())
                    iCurrPlace = qiNextNeighbour.front();
                iNextPlace = 0;
            }
        }
        if (bUsed[iAskTo])
            bResult.push_back(1);
        else
            bResult.push_back(0);
        for (int i = 0; i < iRoads; ++ i)
            if (bUsed[i])
                for (int j = 0; j < iRoads; ++ j)
                    if (bUsed[j])
                        bMatrix[i][j] = 1;
        for (int i = 0; i < 2001; ++ i)
            bUsed[i] = 0;
    }
    for (int i = 0; i < bResult.size(); ++ i)
        cout << bResult[i];
    cout << endl;
    return 0;
}
/*
9 9
1 2
3 4
5 6
7 8
9 5
7 2
8 2
6 9
1 7
3
1 8
6 2
4 7
*/
