#include <iostream>
#include <map>
#include <set>
#include <string>
using namespace std;

bool foundAnswer=true;
set<int> visited;
string answer = "";

void print_map(map<int,set<int>> web)
{
    cout<<endl;
    map<int,set<int>>::iterator itm = web.begin();
    for(;itm!=web.end();itm++)
    {
        cout<<(*itm).first<<" {";
        for(set<int>::iterator its=(*itm).second.begin(); its!=(*itm).second.end(); its++){
            cout<<(*its)<<" ";
        }
        cout<<"}"<<endl;
    }
    cout<<endl;
}

void getNextNode(map<int,set<int>> web, int node, int c2){
    if(foundAnswer==true) return;
    if(visited.count(node)!=0) return;
    
    visited.insert(node);
    
    if(web[node].count(c2)!=0){
        answer+="1";
        foundAnswer=true;
        return; 
    }
    
    for(set<int>::iterator its=web[node].begin(); its!=web[node].end(); its++){
        //if((*it)>node && (*it)<c2){
            getNextNode(web, (*its), c2);
    }
}

void ask(map<int,set<int>> web, int c1, int c2){
    if(foundAnswer==false) answer+="0";
    if(c2<c1) swap(c1,c2); // taka nomera na purviq grad vinagi e po-maluk ot nomera na vtoriq
    foundAnswer=false;
    visited.clear();
    
    getNextNode(web, c1, c2);   
}

void clean(map<int,set<int>> web, int c1, int c2){
    web[c1].insert(c2);
    web[c2].insert(c1);
    //print_map(web);
}

void report(map<int,set<int>> web, int c1, int c2){
    web[c1].erase(c2);
    web[c2].erase(c1);
    //print_map(web);
    /*
    set<int>::iterator its = web[c1].find(c2);
    set<int> temp;
    for(set<int>::iterator its= web[c1].begin(); its!=web[c1].end();its++){
        if((*its)==c2){
            cout<<"*its1="<<*its<<endl;
            temp.insert(*its);
        }
    }
    web[c1]=temp;
    temp.clear();
    
    for(set<int>::iterator its= web[c2].begin(); its!=web[c2].end();its++){
        if((*its)==c1) {
            cout<<"*its2="<<*its<<endl;
            temp.insert(*its);
        }
    }
    web[c2]=temp;
    print_map(web);
    */
}


int main()
{
    int cities, routs;
    cin>>cities>>routs;
    
    map<int,set<int>> web;

    int c1,c2;
    for(int i=0; i<routs; i++){
        cin>>c1>>c2;
        web[c1].insert(c2);
        web[c2].insert(c1);
    }
    //print_map(web);
    
    int calls;
    cin>>calls;
    int codes[calls];
    int starts[calls];
    int finishes[calls];
    for(int i=0;i<calls;i++){
        cin>>codes[i]>>starts[i]>>finishes[i];
    }
    for(int i=0;i<calls;i++){
        switch(codes[i]){
                case 1: ask(web, starts[i], finishes[i]); break;
                case 2: clean(web, starts[i], finishes[i]); break;
                case 3: report(web, starts[i], finishes[i]); break;
            }
    }
    if(foundAnswer==false) answer+="0";
    cout<<endl<<answer<<endl;
    return 0;
}









