#include <iostream>

using namespace std;

int main()
{
    
    int numberOfTowns = 2;
    int pathsLeft;
        
    cin >> numberOfTowns >> pathsLeft;
        
    int paths[numberOfTowns][numberOfTowns];
  
    for (int i = 0; i < numberOfTowns; i++)
    {
        for (int k = 0; k < numberOfTowns; k++)
        {
            paths[i][k] = 0;
        }
    }  

    for (int i=0; i < pathsLeft; i++)
    {
        int firstTown,secondTown;
        cin >> firstTown >> secondTown;
                
        paths[firstTown-1][secondTown-1] = 1;
        paths[secondTown-1][firstTown-1] = 1;
    }
    
    int numberOfCalls;
    string output = "";
    
    cin >> numberOfCalls;

    for (int i = 0; i < numberOfCalls; i++)
    {
        int firstTown, secondTown, callType;
        
        cin >> callType >> firstTown >> secondTown;
        
        if (callType == 1)
        {
            string a = "0";
            bool available = false;
            bool unavailable = false;
            
            if (firstTown > secondTown)
            {
                int temp = firstTown;
                firstTown = secondTown;
                secondTown =  temp;
            }
            
            int currentTown = firstTown;            
            
            if (paths[firstTown-1][secondTown-1] == 1 || paths[secondTown-1][firstTown-1] == 1) 
            {
                a = "1";
            }
            else
            {                           
                while (available == false && unavailable == false)
                {
                    for (int i = currentTown-1; i < numberOfTowns; i++)
                    {                           
                        for (int k = currentTown-1; k < numberOfTowns; k++)
                        {
                            if (paths[i][secondTown-1] == 1) available = true;
                        }
                        if (i == secondTown-1) unavailable = true;
                    
                    }
                }
            }
            if (available) a = "1";
        
            
            output += a;
        }
        else if (callType == 2)
        {
            paths[firstTown-1][secondTown-1] = 1;
        }
        else if (callType == 3)
        {
            paths[firstTown-1][secondTown-1] = 0;
        }
    }

    cout << output;

}