#include <iostream>
#include <array>
using namespace std;

int paths[1001][1001];
int n;
int m;

string findPath(int from, int to){
    if(from == to){
        return "1";
    }
    for(int i = 0; i < n; i++){
        if(paths[from][i] == 1){            
            paths[from][i] = 0;
            if(findPath(i, to) == "1"){
                return "1";
            }
            paths[from][i] = 1;            
        }
    }    
    return "0";
}

int main(){
    int q;
    string response = "";
    cin >> n >> m;
    
    for(int i = 0; i < n; i++){
        for(int j = 0; j < n; j++){
            paths[i][j] = 0;
        }
    }
    
    for(int i = 0; i < m; i++){
        int from, to;
        cin >> from >> to;
        paths[from][to] = 1;
        paths[to][from] = 1;
    }
    cin >> q;
    for(int i = 0; i < q; i++){
        int type,from,to;
        
        cin >> type >> from >> to;
        
        if(type == 1){        
            if(paths[from][to] == 1){
                response += "1";
            }
            else{                         
                response += findPath(from, to);
            }
        }
        else if(type == 2){
            paths[from][to] = 1;
            paths[to][from] = 1;
        }
        else if(type == 3){
            paths[from][to] = 0;
            paths[to][from] = 0;
        }
    }
    
    cout << response;
    
    return 0;
}