#include <stdio.h>
#include <queue>
#include <utility>

using namespace std;

char ways[1001][1001] = { 0 };
int n;

void addWay( int from, int to )
{
    int i;
    queue<pair<int, int>> q;
    q.push(pair<int, int>(from, to));
    while( !q.empty( ) )
    {
        from = q.front().first;
        to = q.front().second;
        q.pop();
        ways[from][to] = ways[to][from] = 1;
        for( i = 1; i <= n; ++i )
        {
            if( ways[from][i] && !ways[to][i] )
            {
                //ways[from][i] = ways[i][from] = 0;
                q.push(pair<int, int>(i, to));
                //ways[from][i] = ways[i][from] = 1;
            }
            if( ways[to][i] && !ways[from][i] )
            {
                //ways[to][i] = ways[i][to] = 0;
                q.push(pair<int, int>(from, i));
                //ways[to][i] = ways[i][to] = 1;
            }
        }
    }
}
/*
char hasWay( int from, int to )
{
    int i, found = 0;
    if( from == to )
        return 1;
    if( ways[from][to] )
        return 1;
    for( i = 1; i <= n && !found; ++i )
    {
        if( ways[from][i] )
        {
            ways[from][i] = ways[i][from] = 0;
            found |= hasWay( i, to );
            ways[from][i] = ways[i][from] = 1;
        }
    }
    return found;
}
*/
int main( )
{
    int i, m, q, from, to, t;
    scanf( "%i%i", &n, &m );
    for( i = 0; i < m; ++i )
    {
        scanf( "%i%i", &from, &to );
        //ways[from][to] = ways[to][from] = 1;
        addWay( from, to );
    }
    scanf( "%i", &q );
    for( i = 0; i < q; ++i )
    {
        scanf( "%i%i%i", &t, &from, &to );
        if( t == 1 )
        {
            //putchar( hasWay( from, to ) + '0' );
            putchar( ways[from][to] + '0' );
        }
        else
        {
            //ways[from][to] = ways[to][from] = 1;
            addWay( from, to );
        }
    }
    return 0;
}