#include<iostream>
using namespace std;
long long tree[1001]; // vatre vseki vrah pointva kam niakoi drug vrah. te sa ni ot 1 do N, niama da polzvame nuleviat index

long long findRoot(long long point)
{
    while(tree[point] != point) // dokato ne stigne roota
    {
        point = tree[point];
    }
    return point;
}

long long checkDepth(long long point)
{
    long long depth = 0;
    while(tree[point] != point)
    {
        point = tree[point];
        depth++;
    }
    return depth;
}

bool checkConnection(long long point1, long long point2) // ciklim dokato ne dostignem do roota. toi pointva kam sebe si. taka 6te razberem. triabva i 2te da imat edni i sa6ti roots, za da sa connectnati
{
    point1 = findRoot(point1), point2 = findRoot(point2);
    if(point1 == point2)
    {
        return 1;
    }
    return 0; // tova e na6iat else
}

void addNode(long long point1, long long point2)
{
    if( !(checkConnection(point1, point2)) )
    {
        if(checkDepth(point1) >= checkDepth(point2))
        {
            // svarzvame sas po-malkiat depth kam tozi sas po-golemia? taka triabva, za6toto ina4e moze da otneme dosta pove4e, za da se nameri roota za golamoto darvo ako go slozim kam po-malkoto i tova 6te se uveli4i sas edinica
            point1 = findRoot(point1);
            point2 = findRoot(point2);
            tree[point2] = point1; // taka ve4e darvoto sas po-malka dalbo4ina se svarzva kam darvoto sas po-golamata
        }
    }
}
int main()
{
    // input
    long long numVertices, numNodes, numMessages;
    cin>>numVertices>>numNodes;
    
    // initialization
    for(long long vertex = 1; vertex <= numVertices; vertex++)
    {
        tree[vertex] = vertex;
    }
    
    // input
    for(long long node = 0; node < numNodes; node++)
    {
        long long point1, point2;
        cin>>point1>>point2;
        addNode(point1, point2);
    }
    
    // input and output
    cin>>numMessages;
    for(long long message = 0; message < numMessages; message++)
    {
        long long type, point1, point2;
        cin>>type>>point1>>point2;
        if(type == 1)
        {
            cout<<checkConnection(point1, point2);
        }
        else
        {
            addNode(point1, point2);
        }
    }
    cout<<endl; // vav kraia nov red
    // vavezdame dannite
    /*
    pri vavezdaneto na dannite si izgrazdame darvoto. ni6to drugo.
    za vav 4asten slu4ai kato ediniat ni e vrah, a drugiat ni e root mozem da priemem, 4e na samiat root negoviat root si si e samiat sebe si. to i taka 6te si stane
    avtomati4no ot samiat algorithm.
    */
    // initializirame si masiva, vav koito vsi4kite sa si roots i si pointvat kam sebe si - tova za darvoto
	return 0;
}