#include <stdio.h>
#include <algorithm>

using namespace std;

int n, m;

struct Book
{
    float price;
    int pages;
    float pricePerPage;
    Book()
    {
        this -> price = 0.0;
        this -> pages = 0;
        this -> pricePerPage = 0;
    }
};

bool BookCompare(Book a, Book b)
{
    if (a.pricePerPage > b.pricePerPage) return true;
    return false;
}

float maxSum = 0;

void GetSumFrom(int i, Book books[], bool used[], int newM, float current)
{
    float ret = current;
    if (ret > maxSum) maxSum = ret;
    if (newM == 0) return;
    else
    {
        for (int start = i; start < n; start++)
        {
            if ((!used[start - i]) && (books[start].pages <= newM))
            {
                ret += books[start].price;
                used[start - i] = true;
                GetSumFrom(i, books, used, newM - books[start].pages, ret);
                used[start - i] = false;
                ret -= books[start].price;
            }
        }
    }
}

int main()
{
    int newM;
    float answer = 0.0;
    scanf("%d%d", &n, &m);
    newM = m;
    Book books[n];
    for (int i = 0; i < n; i++)
    {
        scanf("%d%f", &books[i].pages, &books[i].price);
        books[i].pricePerPage = books[i].price / books[i].pages;
    }
    sort(books, books + n, BookCompare);
    
    answer = books[0].price;
    newM -= books[0].pages;
    int i = 1;
    while ((newM >= books[i].pages) && (i < n))
    {
        newM -= books[i].pages;
        answer += books[i].price;
        i++;
    }
    if (newM == 0) printf("%.02f\n", answer); 
    else
    {
        i--;
        answer -= books[i].price;
        newM += books[i].pages;
        bool used[n - i];
        for (int j = 0; j < n - i; j++) used[j] = false;
        GetSumFrom(i, books, used, newM, 0);
        answer += maxSum;
        printf("%.02f\n", answer);
    }
    
    return 0;
}