#include <iostream>
#include <cstdio>
#include <cmath>

using namespace std;

double bin (double a, double b, double c, double ul, double ur) {
    if (sqrt(a*a+b*b) <= c) {
        return 0.00;
    }
    if (c==a) return b;
    if (c==b) return a;
    if ((a<c && c < b) || (a>c && c > b)) {
        return min(a,b);
    }
    double q,p,r,mid,z,ans,m;
    while (ul < ur) {
        mid = (ul+ur)/2.0;
        q = c*sin(mid);
        p = c*cos(mid);
        ans = (b-q)/cos(mid);
        r = sin(mid)*ans;
        if (a-r-p >= 0) {
            ul = mid;
        } else {
            ur = mid;
        }
        if (ul+0.0000000000001 > ur) break;
    }
    return ans;
}

int main() {
    double a,b,c;
    cin >> a >> b >> c;
    double q = min(a,b);
    double p = max(a,b);
    a = q;
    b = p;
    printf("%.2f\n",bin(a,b,c,0.0,M_PI/2.0));
    return 0;
}

/*
10000 10000 13
*/
