#include <cstdio>
#include <string.h>
//#include <vector>
#include <iostream>
using namespace std;

#define MAX 2001

int n,m;
int g[MAX][MAX];
int fl[MAX][MAX];
//vector<int> nb[MAX];
long q;

void floyd() {
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= n; ++j) {
            if (fl[j][i]==1) {
                for (int p = 1; p <= n; ++p) {
                    if (fl[i][p]==1) {
                        fl[j][p] = 1;
                        fl[p][j] = 1;
                    }
                }
            }
        }
    }
}

void cl(int a, int b) {
    fl[a][b] = 1;
    fl[b][a] = 1;
    g[a][b] = 1;
    g[b][a] = 1;
    for (int i = 1; i <= n; ++i) {
        if (fl[i][a] || fl[i][b]) {
            for (int j = 1; j <= n; ++j) {
                if (fl[a][j] && fl[i][a]) {
                    fl[i][j] = 1;
                    fl[j][i] = 1;
                }
                if (fl[b][j] && fl[i][b]) {
                    fl[i][j] = 1;
                    fl[j][i] = 1;
                }
            }
        }
    }
}

void del (int a, int b) {
    g[a][b] = 0;
    g[b][a] = 0;
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j<=n; ++j) {
            fl[i][j] = g[i][j];
        }
    }
    floyd();
}

int main() {
    memset(g,0,sizeof(g));
    memset(fl,0,sizeof(fl));
    scanf("%d%d",&n,&m);
    int a,b,c;
    long i;
    for (i = 0; i < m; ++i) {
        scanf("%d%d",&a,&b);
        g[a][b] = 1;
        g[b][a] = 1;
        fl[a][b] = 1;
        fl[b][a] = 1;
        //nb[a].push_back(b);
        //nb[b].push_back(a);
    }
    floyd();
    scanf("%ld",&q);
    for (i = 0; i < q;++i) {
        scanf("%d%d%d",&a,&b,&c);
        if (a==1) {
            printf("%d",fl[b][c]);
        } else if(a==2) {
            cl(b,c);
        } else if (a==3) {
            del(b,c);
        }
    }
    printf("\n");
    return 0;
}

/*
9 8
1 2
3 4
5 6
7 8
9 5
7 2
8 2
6 9
8
1 1 8
1 6 2
2 7 1
1 4 7
2 2 3
1 4 7
3 3 4
1 4 7
*/
