#include <iostream>
#include <cstdio>
#include <cstring>

using namespace std;

const int MAXN = 1024;
const int MAXQ = 1000000 + 5;

char ans[MAXQ];
int root[MAXN];

int Root(int a) {
    int a1 = a;

    while(root[a] != -1) a = root[a];
    int r = a;

    a = a1;
    int e;

    while(root[a] != -1)
        e = root[a],
        root[a] = r,
        a = e;

    return r;
    }

void Union(int a, int b) {
    int r1 = Root(a), r2 = Root(b);
    if(r1 != r2) root[r2] = r1;
    }

int main() {
    memset(root, -1, sizeof(root));

    int n, m;
    scanf("%d%d", &n, &m);

    int a, b;
    while(m--)
        scanf("%d%d", &a, &b),
        Union(a, b);

    int q;
    scanf("%d", &q);

    int sz = 0;
    int cmd;

    while(q--) {
        scanf("%d%d%d", &cmd, &a, &b);
        if(cmd == 1) ans[sz++] = '0' + (Root(a) == Root(b));
        else Union(a, b);
        }

    ans[sz] = 0;
    printf("%s\n", ans);
    return 0;
    }
