#include <iostream>
#include <vector>
#define mx_in 1024
using namespace std;
vector <int> in[mx_in];
int state[mx_in];
int n,m,q,mark;

void dfs(int x)
{
    for(int i=0;i<in[x].size();i++)
        if(state[in[x][i]]==0)
        {
            state[in[x][i]]=mark;
            dfs(in[x][i]);
        }
}

void setup()
{
    int a,b,i;
    cin >> n >> m;
    for(i=0;i<m;i++)
    {
        cin >> a >> b;
        in[a].push_back(b);
        in[b].push_back(a);
    }
    for(i=1;i<=n;i++)
        if(state[i]==0)
        {
            mark++;
            dfs(i);
        }
}

void update(int x,int y)
{
    int a=state[x],b=state[y];
    if(a==b)return ;
    else
    {
        if(b<a){int c=a;a=b;b=c;}
        for(int i=0;i<n;i++)if(state[i]==b)state[i]=a;
    }
}

void serve()
{
    int a,b,c;
    cin >> q;
    for(int i=0;i<q;i++)
    {
        cin >> a >> b >> c;
        if(a==1)cout << (state[b]==state[c]);
        else if(a==2) update(b,c);
    }
    cout << endl;
}

int main()
{
    setup();
    serve();
    return 0;
}
