#include <iostream>
#include <stdio.h>
#include <vector>
using namespace std;
typedef long long Int;

Int father[1001];
vector<Int> Graph[1001];
bool TFO[1001];
Int tail[1001];
Int tL;

void BFS(Int k)
{
    Int uk;
    Int cv,nv;
    Int i;
    
    tL=1;
    tail[1]=k;
    TFO[k]=true;
    uk=1;
    
    while(uk<=tL)
    {
        cv=tail[uk];
        for (i=0;i<Graph[cv].size();i++)
        {
            nv=Graph[cv][i];
            
            if (!TFO[nv])
            {
                father[nv]=k;
                TFO[nv]=true;
                tL++;
                tail[tL]=nv;
            }
        }
        
        uk++;
    }
    
    return;
}

Int FindRoot(Int ver)
{
    if (father[ver]==0)
    return ver;
    else
    {
        Int r=FindRoot(father[ver]);
        father[ver]=r;
        return r;
    }
}

int main()
{
    Int n,m,q;
    Int a,b;
    Int v1,v2,command;
    Int r1,r2;
    Int i;
    
    scanf("%lld %lld",&n,&m);
    
    for (i=0;i<=1000;i++)
    {
        Graph[i].clear();
        TFO[i]=false;
        father[i]=0;
    }
    
    for (i=1;i<=m;i++)
    {
        scanf("%lld %lld",&a,&b);
        
        Graph[a].push_back(b);
        Graph[b].push_back(a);
    }
    
    for (i=1;i<=n;i++)
    {
        if (!TFO[i])
        {
            BFS(i);
        }
    }
    
    scanf("%lld",&q);
    
    for (i=1;i<=q;i++)
    {
        scanf("%lld %lld %lld",&command,&v1,&v2);
        
        if (command==1)
        {
            r1=FindRoot(v1);
            r2=FindRoot(v2);
            
            if (r1==r2)
            {
                printf("1");
            }
            else
            {
                printf("0");
            }
        }
        else
        {
            r1=FindRoot(v1);
            r2=FindRoot(v2);
            
            if (r1!=r2)
            father[r2]=r1; ///Union
        }
    }
    
    printf("\n");
    
    return 0;
}
/**
9 8
1 2
3 4
5 6
7 8
9 5
7 2
8 2
6 9
6
1 1 8
1 6 2
2 7 1
1 4 7
2 2 3
1 4 7
**/